



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>JS特殊函数(Function()构造函数、函数直接量)区别介绍</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">JS特殊函数(Function()构造函数、函数直接量)区别介绍</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-20 20:22:56 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>函数定义</strong>&nbsp;<br />函数是由这样的方式进行声明的：关键字 function、函数名、一组参数，以及置于括号中的待执行代码。&nbsp;<br />函数的构造语法有这三种：</p>
<div>
<pre class="prettyprint linenums">1.function functionName(arg0, arg1, ... argN) { statements }//function语句<br />
2.var function_name = new Function(arg1, arg2, ..., argN, function_body);//Function()构造函数<br />
3.var func = function(arg0, arg1, ... argN) { statements };//函数直接量 </pre>
</div>
<p>示例：</p>
<div>
<pre class="prettyprint linenums">function f(x){return x*x};//function语句<br />
var f = new Function("x","return x*x;");//Function()构造函数<br />
var f = function(x){return x*x;};//函数直接量 </pre>
</div>
<p>如果函数无明确的返回值，或调用了没有参数的 return 语句，那么它真正返回的值是 undefined。</p>
<p><strong>Function()构造函数</strong></p>
<p>函数实际上是功能完整的对象 。Function类可以表示开发者定义的任何函数。用Function类直接创建函数的语法如下：&nbsp;<br />var function_name = new function(arg1, arg2, ..., argN, function_body)&nbsp;<br />在上面的形式中，每个 arg 都是一个参数，最后一个参数是函数主体（要执行的代码）。这些参数必须是字符串。&nbsp;<br />var sayHi = new Function("sName", "sMessage", "alert('Hello ' + sName + sMessage);");&nbsp;<br />sayHi("jzj,", "你好!");//Hello jzj，你好！&nbsp;<br />函数名只是指向函数的变量，那么可以把函数作为参数传递给另一个函数吗？答案是可以的，请看：</p>
<div>
<pre class="prettyprint linenums">function callAnotherFunc(fnFunction, vArgument) {<br />
fnFunction(vArgument);<br />
}<br />
var doAdd = new Function("iNum", "alert(iNum + 10)");<br />
callAnotherFunc(doAdd, 10); //输出 "20" </pre>
</div>
<p>注意：尽管可以使用 Function 构造函数创建函数，但最好不要使用它，因为用它定义函数比用传统方式要慢得多。不过，所有函数都应看作 Function 类的实例 。&nbsp;<br />如果你定义的函数没有参数，那么可以只需给构造函数传递一个字符串（即函数的主体）即可。&nbsp;<br />注意：传递给构造函数Function()的参数中没有一个用于说明它要创建的函数名。用Function()构造函数创建的未命名函数有时被称为&ldquo;匿名函数&rdquo;。&nbsp;<br />Function()函数允许我们动态地建立和编译一个函数，它不会将我们限制在function语句预编译的函数体中。</p>
<p><strong>Function()构造函数和函数直接量差别</strong>&nbsp;<br />Function()构造函数和函数直接量之间的差别有一点就是：使用构造函数Function()创建的函数不使用词法作用域，相反的，它们总是被顶级函数来编译，如：</p>
<div>
<pre class="prettyprint linenums">var y = "global";<br />
function constructFunction() {<br />
var y = "local";<br />
//Function()构造函数<br />
return new Function("return y;");//不使用局部作用域<br />
}<br />
function constFunction() {<br />
var y = "local";<br />
//函数直接量<br />
var f = function () {<br />
return y;//使用局部作用域<br />
};<br />
return f;<br />
}<br />
//显示 global，因为Function()构造函数返回的函数并不使用局部作用域<br />
alert(constructFunction()());<br />
//显示 lobal，因为函数直接量返回的函数并使用局部作用域<br />
alert(constFunction()()); </pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/rqlple19.html">Ubuntu 14&period;04上安装caffe</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9p4od49.html">传值  属性 block 单例 协议</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd466gq.html">【原创】Docker容器及Spring Boot微服务应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdekvz79.html">Android改变了PDA市场格局</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvnx4jq.html">iOS开发UI篇-tableView在编辑状态下的批量操作&lpar;多选&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wndp3q.html">java与&period;net平台之间进行RSA加密验证</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy12ymdq.html">Jquery实现表格的分页</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgwd378.html">pymysql实现MySQL与Python交互</a>
		</li>
						<li><a href="https://www.batexi.com/a/9502rjv8.html">SQL SERVER获取信息的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjjl0l9.html">java时间类Date、Calendar及用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wp33nq.html">Node中的模块引入机制</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdlpk09.html">【原】本地仓库推送到远程仓库：fatal&colon; refusing to merge unrelated histories</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j174049.html">让网站不去请求favicon&period;ico图标</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2w6ex9.html">&lbrack;django&rsqb;django model的查询和更新</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kom52jq.html">YII2 model 字段验证提示  Unknown scenario&colon; update</a>
		</li>
						<li><a href="https://www.batexi.com/a/953pvg08.html">iOS开发中id、NSObject &ast;、id、instancetype四者有什么区别？</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ely7k9.html">javascript面向对象的一些写法</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql12k119.html">jsp&amp;amp&semi;html页面知识点集锦</a>
		</li>
						<li><a href="https://www.batexi.com/a/963kvnv9.html">&lbrack;k8s&rsqb;elk架构设计-k8s集群里搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvd2l7yq.html">Hadoop Federation联邦</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/xq4vy5jq.html">Redis redis-cli常用操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/390xv339.html">hdu2297Run（凸包的巧妙应用）</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8kgon79.html">在应用程序级别之外使用注册为 allowDefinition&equals;&amp;&num;39&semi;MachineToApplication&amp;&num;39&semi; 的节是错误的</a>
			</li>
						<li><a href="https://www.batexi.com/a/390xjlj9.html">win7任务栏只显示日期不显示年月日</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8znjvd8.html">Octopus系列之js公共函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4vnd5q.html">C&num; Enum 简易权限设计 使用FlagsAttribute属性</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7yn4jq.html">iOS开发拓展篇&mdash;CoreLocation简单介绍</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqd4k1vq.html">使用rpm命令卸载程序</a>
			</li>
						<li><a href="https://www.batexi.com/a/39rr7l79.html">javascript的坑</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqd4g77q.html">《大象-Think In UML》读书笔记2</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
